/********************************************************************/
/*																	*/
/*		Knihovna funkci pro FZ012010								*/
/*		[c] Filip Zaplata, FEKT VUT v Brne 2010						*/
/*																	*/
/********************************************************************/

extern unsigned int adcnt;
extern unsigned char PRIZNAK, TLLED, TLLED_ST, TLLED_DL;
extern unsigned char odm[256];
extern char rotace, addata[];
//as pro dlouh stisk tlatka
#define CAS_DL	80

//obnovovac frekvence
#define CAS_O	158

//PORTC
#define OE		5
#define CLK		4
#define DAT4	3
#define DAT3	2
#define DAT2	1
#define DAT1	0

//PORTB
#define LA		2
#define MPX1	1
#define MPX2	0

//PORTD
#define T3		7
#define T2		6
#define T1		5
#define T		4
#define R2		3
#define R1		2
#define TR		1
#define DEN		0

//PRIZNAK
#define ADR		5
#define OBR		4
#define ROT		3
#define TL		2
#define T_ST	1
#define T_DL	0

//TLLED
#define TL3		7
#define TL2		6
#define TL1		5
#define TLC		4
#define TLR		3
#define LED3	2
#define LED2	1
#define LED1	0

extern void init(void);

extern void zobr(unsigned int *dat);

extern void ledtl(void);

extern void posun(char N, unsigned int *dat, unsigned char ndat);

extern void kopie(int N, unsigned char *vst, int nvst, unsigned int *vyst, char nvyst);

extern unsigned char absh(char *m1, char *m2);

extern inline char soucin(char m1, char m2);

extern void rFFT(char *dat, unsigned char n);

extern void adstart(char ch, unsigned int n);

extern void decimace(char *vstup, char *vystup, int n, unsigned char d);

extern int kod_text(char *pole);

extern void stop_ad(void);

//*******************************************************************
//*	makro DP IIR 3. rad elip										*
//*******************************************************************

#define IIR_LP01(data, N)					\
asm volatile(								\
	"add	%A0, %A1						\n\t"/*data+N*/\ 
	"adc	%B0, %B1						\n\t"\
	"clr	r6								\n\t"/*Z<-0*/\
	"clr	r7								\n\t"\
	"clr	r8								\n\t"\
	"clr	r9								\n\t"\
	"clr	r10								\n\t"\
	"clr	r11								\n\t"\
	"clr	r12								\n\t"\
	"clr	r13								\n\t"\
	"clr	r14								\n\t"/*nul registr*/\
	"clr	r18								\n\t"\
	"clr	r19								\n\t"\
	"clr	r20								\n\t"\
	"clr	r21								\n\t"\
	"clr	r22								\n\t"\
	"clr	r23								\n\t"\
	"clr	r24								\n\t"\
	"clr	r25								\n\t"\
	"L0_%=:									"/*hlavni smycka*/\
	"ld		r16, -x							\n\t"/*pom1*/\
	"ldi	r17, 65							\n\t"\
	"muls	r16, r17						\n\t"\
	"movw	r2, r0							\n\t"\
	"ldi	r17, -50						\n\t"/*pom2*/\
	"muls	r16, r17						\n\t"\
	"movw	r4, r0							\n\t"\
	"sbrc	r3, 7							\n\t"\
	"dec	r14								\n\t"\
	"add	r22, r2							\n\t"/*pom1+Z1*/\
	"adc	r23, r3							\n\t"\
	"adc	r24, r14						\n\t"\
	"clr	r14								\n\t"\
	"ldi	r17, 0x03						\n\t"/*xa0*/\
	"mul	r22, r17						\n\t"\
	"movw	r18, r0							\n\t"\
	"muls	r24, r17						\n\t"\
	"mov	r20, r0							\n\t"\
	"mul	r23, r17						\n\t"\
	"add	r19, r0							\n\t"\
	"adc	r20, r1							\n\t"\
	"tst	r18								\n\t"/*zaokrouhleni*/\
	"brpl	L1_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r19, r17						\n\t"\
	"adc	r20, r14						\n\t"\
	"L1_%=:									"\
	"mov	r18, r19						\n\t"/*>>8*/\
	"mov	r19, r20						\n\t"\
	"clr	r20								\n\t"\
	"sbrc	r19, 7							\n\t"\
	"dec	r20								\n\t"\
	"ldi	r17, 0x76						\n\t"/*Z0xa1*/\
	"muls	r19, r17						\n\t"\
	"movw	r24, r0							\n\t"\
	"ldi	r17, 0xf0						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r22, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r25, r14						\n\t"\
	"add	r23, r0							\n\t"\
	"adc	r24, r1							\n\t"\
	"adc	r25, r14						\n\t"\
	"ldi	r17, 0x76						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r25, r14						\n\t"\
	"add	r23, r0							\n\t"\
	"adc	r24, r1							\n\t"\
	"adc	r25, r14						\n\t"\
	"lsl	r22								\n\t"\
	"rol	r23								\n\t"\
	"rol	r24								\n\t"\
	"rol	r25								\n\t"\
	"tst	r22								\n\t"/*zaokrouhleni*/\
	"brpl	L2_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r23, r17						\n\t"\
	"adc	r24, r14						\n\t"\
	"adc	r25, r14						\n\t"\
	"L2_%=:									"\
	"mov	r22, r23						\n\t"/*>>8*/\
	"mov	r23, r24						\n\t"\
	"mov	r24, r25						\n\t"\
	"add	r22, r6							\n\t"/*+Z2*/\
	"adc	r23, r7							\n\t"\
	"adc	r24, r8							\n\t"\
	"sbrc	r5, 7							\n\t"\
	"dec	r14								\n\t"\
	"add	r22, r4							\n\t"/*+pom2*/\
	"adc	r23, r5							\n\t"\
	"adc	r24, r14						\n\t"\
	"clr	r14								\n\t"\
	"ldi	r17, 0x90						\n\t"/*Z0xa2*/\
	"muls	r19, r17						\n\t"\
	"movw	r8, r0							\n\t"\
	"ldi	r17, 0x7f						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r6, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r9, r14							\n\t"\
	"add	r7, r0							\n\t"\
	"adc	r8, r1							\n\t"\
	"adc	r9, r14							\n\t"\
	"ldi	r17, 0x90						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r9, r14							\n\t"\
	"add	r7, r0							\n\t"\
	"adc	r8, r1							\n\t"\
	"adc	r9, r14							\n\t"\
	"lsl	r6								\n\t"\
	"rol	r7								\n\t"\
	"rol	r8								\n\t"\
	"rol	r9								\n\t"\
	"tst	r6								\n\t"/*zaokrouhleni*/\
	"brpl	L3_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r7, r17							\n\t"\
	"adc	r8, r14							\n\t"\
	"adc	r9, r14							\n\t"\
	"L3_%=:									"\
	"mov	r6, r7							\n\t"/*>>8*/\
	"mov	r7, r8							\n\t"\
	"mov	r8, r9							\n\t"\
	"add	r6, r10							\n\t"/*+Z3*/\
	"adc	r7, r11							\n\t"\
	"adc	r8, r12							\n\t"\
	"sbrc	r5, 7							\n\t"\
	"dec	r14								\n\t"\
	"add	r6, r4							\n\t"/*+pom2*/\
	"adc	r7, r5							\n\t"\
	"adc	r8, r14							\n\t"\
	"clr	r14								\n\t"\
	"ldi	r17, 0x23						\n\t"/*Z0xa3*/\
	"muls	r19, r17						\n\t"\
	"movw	r12, r0							\n\t"\
	"ldi	r17, 0x1f						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r10, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r13, r14						\n\t"\
	"add	r11, r0							\n\t"\
	"adc	r12, r1							\n\t"\
	"adc	r13, r14						\n\t"\
	"ldi	r17, 0x23						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r13, r14						\n\t"\
	"add	r11, r0							\n\t"\
	"adc	r12, r1							\n\t"\
	"adc	r13, r14						\n\t"\
	"lsl	r10								\n\t"\
	"rol	r11								\n\t"\
	"rol	r12								\n\t"\
	"rol	r13								\n\t"\
	"tst	r10								\n\t"/*zaokrouhleni*/\
	"brpl	L4_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r11, r17						\n\t"\
	"adc	r12, r14						\n\t"\
	"adc	r13, r14						\n\t"\
	"L4_%=:									"\
	"mov	r10, r11						\n\t"/*>>8*/\
	"mov	r11, r12						\n\t"\
	"mov	r12, r13						\n\t"\
	"sbrc	r3, 7							\n\t"\
	"dec	r14								\n\t"\
	"add	r10, r2							\n\t"/*+pom1*/\
	"adc	r11, r3							\n\t"\
	"adc	r12, r14						\n\t"\
	"clr	r14								\n\t"\
	"lsl	r18								\n\t"\
	"rol	r19								\n\t"\
	"sbrc	r18, 7							\n\t"/*zaokrouhleni*/\
	"inc	r19								\n\t"\
	"st		x, r19							\n\t"/*->data*/\
	"subi	%A1, 1							\n\t"/*i--*/\
	"sbci	%B1, 0							\n\t"\
	"cp		%A1, r14						\n\t"\
	"cpc	%B1, r14						\n\t"\
	"breq	E0_%=							\n\t"\
	"rjmp	L0_%=							\n\t"\
	"E0_%=:									"\
	"clr	__zero_reg__					"\
	:										\
	:"x" ((char*)(data)), "r" ((int)(N))	\
	:"r2", "r3", "r4", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r16", "r17", "r18", "r19", "r20", "r21", "r22", "r23", "r24", "r25"\
	)

//*******************************************************************
//*	makro HP IIR 3. rad elip										*
//*******************************************************************

#define IIR_HP01(data, N)					\
asm volatile(								\
	"add	%A0, %A1						\n\t"/*data+N*/\ 
	"adc	%B0, %B1						\n\t"\
	"clr	r6								\n\t"/*Z<-0*/\
	"clr	r7								\n\t"\
	"clr	r8								\n\t"\
	"clr	r9								\n\t"\
	"clr	r10								\n\t"\
	"clr	r11								\n\t"\
	"clr	r12								\n\t"\
	"clr	r13								\n\t"\
	"clr	r14								\n\t"/*nul registr*/\
	"clr	r18								\n\t"\
	"clr	r19								\n\t"\
	"clr	r20								\n\t"\
	"clr	r21								\n\t"\
	"clr	r22								\n\t"\
	"clr	r23								\n\t"\
	"clr	r24								\n\t"\
	"clr	r25								\n\t"\
	"L0_%=:									"/*hlavni smycka*/\
	"ld		r16, -x							\n\t"/*pom1*/\
	"ldi	r17, 0x24						\n\t"\
	"sbrc	r16, 7							\n\t"\
	"dec	r14								\n\t"\
	"mov	r16, r14						\n\t"\
	"muls	r16, r17						\n\t"\
	"mov	r4, r0							\n\t"\
	"ld		r16, x							\n\t"\
	"ldi	r17, 0x7D						\n\t"\
	"mul	r16, r17						\n\t"\
	"movw	r2, r0							\n\t"\
	"ldi	r17, 0x24						\n\t"\
	"mulsu	r17, r16						\n\t"\
	"add	r3, r0							\n\t"\
	"adc	r4, r1							\n\t"\
	"ldi	r17, 0x7D						\n\t"\
	"mov	r16, r14						\n\t"\
	"mulsu	r16, r17						\n\t"\
	"add	r3, r0							\n\t"\
	"adc	r4, r1							\n\t"\
	"clr	r14								\n\t"\
	"add	r22, r2							\n\t"/*pom1+Z1*/\
	"adc	r23, r3							\n\t"\
	"adc	r24, r4							\n\t"\
	"push	r2								\n\t"\
	"push	r3								\n\t"\
	"push	r4								\n\t"/*pom2*/\
	"ld		r16, x							\n\t"/*pom1*/\
	"ldi	r17, 0x92						\n\t"\
	"sbrc	r16, 7							\n\t"\
	"dec	r14								\n\t"\
	"mov	r16, r14						\n\t"\
	"muls	r16, r17						\n\t"\
	"mov	r4, r0							\n\t"\
	"ld		r16, x							\n\t"\
	"ldi	r17, 0xA1						\n\t"\
	"mul	r16, r17						\n\t"\
	"movw	r2, r0							\n\t"\
	"ldi	r17, 0x92						\n\t"\
	"mulsu	r17, r16						\n\t"\
	"add	r3, r0							\n\t"\
	"adc	r4, r1							\n\t"\
	"ldi	r17, 0xA1						\n\t"\
	"mov	r16, r14						\n\t"\
	"mulsu	r16, r17						\n\t"\
	"add	r3, r0							\n\t"\
	"adc	r4, r1							\n\t"\
	"clr	r14								\n\t"\
	"ldi	r17, 0x03						\n\t"/*xa0*/\
	"mul	r22, r17						\n\t"\
	"movw	r18, r0							\n\t"\
	"muls	r24, r17						\n\t"\
	"mov	r20, r0							\n\t"\
	"mul	r23, r17						\n\t"\
	"add	r19, r0							\n\t"\
	"adc	r20, r1							\n\t"\
	"tst	r18								\n\t"/*zaokrouhleni*/\
	"brpl	L1_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r19, r17						\n\t"\
	"adc	r20, r14						\n\t"\
	"L1_%=:									"\
	"mov	r18, r19						\n\t"/*>>8*/\
	"mov	r19, r20						\n\t"\
	"clr	r20								\n\t"\
	"sbrc	r19, 7							\n\t"\
	"dec	r20								\n\t"\
	"ldi	r17, 0x72						\n\t"/*Z0xa1*/\
	"muls	r19, r17						\n\t"\
	"movw	r24, r0							\n\t"\
	"ldi	r17, 0xC3						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r22, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r25, r14						\n\t"\
	"add	r23, r0							\n\t"\
	"adc	r24, r1							\n\t"\
	"adc	r25, r14						\n\t"\
	"ldi	r17, 0x72						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r25, r14						\n\t"\
	"add	r23, r0							\n\t"\
	"adc	r24, r1							\n\t"\
	"adc	r25, r14						\n\t"\
	"lsl	r22								\n\t"\
	"rol	r23								\n\t"\
	"rol	r24								\n\t"\
	"rol	r25								\n\t"\
	"tst	r22								\n\t"/*zaokrouhleni*/\
	"brpl	L2_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r23, r17						\n\t"\
	"adc	r24, r14						\n\t"\
	"adc	r25, r14						\n\t"\
	"L2_%=:									"\
	"mov	r22, r23						\n\t"/*>>8*/\
	"mov	r23, r24						\n\t"\
	"mov	r24, r25						\n\t"\
	"add	r22, r6							\n\t"/*+Z2*/\
	"adc	r23, r7							\n\t"\
	"adc	r24, r8							\n\t"\
	"add	r22, r2							\n\t"/*+pom2*/\
	"adc	r23, r3							\n\t"\
	"adc	r24, r4							\n\t"\
	"ldi	r17, 0x98						\n\t"/*Z0xa2*/\
	"muls	r19, r17						\n\t"\
	"movw	r8, r0							\n\t"\
	"ldi	r17, 0xB6						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r6, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r9, r14							\n\t"\
	"add	r7, r0							\n\t"\
	"adc	r8, r1							\n\t"\
	"adc	r9, r14							\n\t"\
	"ldi	r17, 0x98						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r9, r14							\n\t"\
	"add	r7, r0							\n\t"\
	"adc	r8, r1							\n\t"\
	"adc	r9, r14							\n\t"\
	"lsl	r6								\n\t"\
	"rol	r7								\n\t"\
	"rol	r8								\n\t"\
	"rol	r9								\n\t"\
	"tst	r6								\n\t"/*zaokrouhleni*/\
	"brpl	L3_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r7, r17							\n\t"\
	"adc	r8, r14							\n\t"\
	"adc	r9, r14							\n\t"\
	"L3_%=:									"\
	"mov	r6, r7							\n\t"/*>>8*/\
	"mov	r7, r8							\n\t"\
	"mov	r8, r9							\n\t"\
	"add	r6, r10							\n\t"/*+Z3*/\
	"adc	r7, r11							\n\t"\
	"adc	r8, r12							\n\t"\
	"sub	r6, r2							\n\t"/*-pom2*/\
	"sbc	r7, r3							\n\t"\
	"sbc	r8, r4							\n\t"\
	"pop	r4								\n\t"\
	"pop	r3								\n\t"\
	"pop	r2								\n\t"\
	"ldi	r17, 0x1F						\n\t"/*Z0xa3*/\
	"muls	r19, r17						\n\t"\
	"movw	r12, r0							\n\t"\
	"ldi	r17, 0x02						\n\t"\
	"mul	r18, r17						\n\t"\
	"movw	r10, r0							\n\t"\
	"mulsu	r19, r17						\n\t"\
	"sbc	r13, r14						\n\t"\
	"add	r11, r0							\n\t"\
	"adc	r12, r1							\n\t"\
	"adc	r13, r14						\n\t"\
	"ldi	r17, 0x1F						\n\t"\
	"mulsu	r17, r18						\n\t"\
	"sbc	r13, r14						\n\t"\
	"add	r11, r0							\n\t"\
	"adc	r12, r1							\n\t"\
	"adc	r13, r14						\n\t"\
	"lsl	r10								\n\t"\
	"rol	r11								\n\t"\
	"rol	r12								\n\t"\
	"rol	r13								\n\t"\
	"tst	r10								\n\t"/*zaokrouhleni*/\
	"brpl	L4_%=							\n\t"\
	"ldi	r17,1							\n\t"\
	"add	r11, r17						\n\t"\
	"adc	r12, r14						\n\t"\
	"adc	r13, r14						\n\t"\
	"L4_%=:									"\
	"mov	r10, r11						\n\t"/*>>8*/\
	"mov	r11, r12						\n\t"\
	"mov	r12, r13						\n\t"\
	"sub	r10, r2							\n\t"/*-pom1*/\
	"sbc	r11, r3							\n\t"\
	"sbc	r12, r4							\n\t"\
	"lsl	r18								\n\t"\
	"rol	r19								\n\t"\
	"sbrc	r18, 7							\n\t"/*zaokrouhleni*/\
	"inc	r19								\n\t"\
	"st		x, r19							\n\t"/*->data*/\
	"subi	%A1, 1							\n\t"/*i--*/\
	"sbci	%B1, 0							\n\t"\
	"cp		%A1, r14						\n\t"\
	"cpc	%B1, r14						\n\t"\
	"breq	E0_%=							\n\t"\
	"rjmp	L0_%=							\n\t"\
	"E0_%=:									"\
	"clr	__zero_reg__					"\
	:										\
	:"x" ((char*)(data)), "r" ((int)(N))	\
	:"r2", "r3", "r4", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r16", "r17", "r18", "r19", "r20", "r21", "r22", "r23", "r24", "r25"\
	)
